/*
 *
 *	(c) Petr Susil 2006 <susa@atrey.karlin.mff.cuni.cz>
 *
 *	This software may be freely distributed and used according to the terms
 *	of the GNU General Public License.
 */

#ifndef FAGIN_H
#define FAGIN_H
#include <netinet/in.h>
#include "file.h"

int test_already_inserted;
/*
 * return 0 if item found
 * return 1 if item inserted
 */
int insert(hash_table* table,
	   const void* item
	   );
int chain_insert(hash_table* table
		 , void* item
		 , void* (* NEXT_CHAIN_ITEM) (void *chain)
		 , int (* WRITE_CHAIN_ITEM) (file_t* file, uint32_t kam, void* co)
		 , uint32_t ( *GET_IDENTIFIER) (void* item)
		 , unsigned int ITEM_LENGTH
		 );
/* bude provadet kontrolu zda je jiz polozka vlozena */
void   set_check_inserted() ;
/* nebude provadet kontrolu zda je jiz polozka vlozena */
void unset_check_inserted() ;

/*
 * return address of found item
 * or 0 if not found
 */
//uint32_t* find(hash_table*,const void*);

int find(hash_table* table
	       , const void* key
	       , int (*found_item_callback) (uint32_t adr)
	       , int (*chain_found_item_callback) (uint32_t adr)
	       );

void list(hash_table* table, void (*action) (uint32_t adr));
void chain_length_counter(hash_table* table);

void create_folder(hash_table* table, unsigned int bits);
/*
 * return address of found and deleted
 * or 0 if not found
 */
uint32_t delete(hash_table*,const void*);
//uint32_t delete_all_FILE_ONLY(hash_table*  , const void*);
int delete_all_FILE_IDENT(hash_table* table , const void* fi_key);
int delete_all_FILE_IDENT_chain(hash_table* table , const void* fi_key);

/* int enlarge_folder(hash_table* table); */

/* folder_page read_folder(file_t* file, uint32_t folder_address); */
/* folder_page folder_alloc(hash_table* table, int used_bytes); */
/* void folder_free(hash_table* folder); */

#endif
