/*
 *
 *	(c) Petr Susil 2006 <susa@atrey.karlin.mff.cuni.cz>
 *
 *	This software may be freely distributed and used according to the terms
 *	of the GNU General Public License.
 */

#define PREALLOC_PAGES
#define CREATE_FOLDER
#define INCLUDE_COLLISIONS_IN_COUNTING_FOLDER_SIZE

#include "base/macros.h"


int optimize_struct;


static void init_struct()    ;
static void struct_destroy() ;
static void save_struct_t()  ;

#define STRUCT_NAME macro_use
#include "addstruct4.h"
#define STRUCT_NAME macro_def
#include "addstruct4.h"
#define STRUCT_NAME variable_dec
#include "addstruct4.h"
#define STRUCT_NAME function_dec
#include "addstruct4.h"
#define STRUCT_NAME function_def
#include "addstruct4.h"
#define STRUCT_NAME function_use
#include "addstruct4.h"
#define STRUCT_NAME typedef_
#include "addstruct4.h"
#define STRUCT_NAME typedef_use
#include "addstruct4.h"
#define STRUCT_NAME struct_dec
#include "addstruct4.h"
#define STRUCT_NAME struct_def
#include "addstruct4.h"
#define STRUCT_NAME struct_use
#include "addstruct4.h"
#define STRUCT_NAME include
#include "addstruct4.h"

#if 1
#define STRUCT_NAME included
#include "addstruct2.h"
#endif

#define STRUCT_NAME variable_use
#include "addstruct7.h"

#define DO_STUFFS    \
 DO(macro_use)    \
 DO(macro_def)    \
 DO(variable_dec) \
 DO(function_dec) \
 DO(function_def) \
 DO(function_use) \
 DO(typedef_)     \
 DO(typedef_use)  \
 DO(struct_dec)   \
 DO(struct_def)   \
 DO(struct_use)   \
 DO(include)      \
 DO(included)     \
 DO(variable_use)


static void init_struct()
{
#define DO(x)  init_ ## x ();
DO_STUFFS
#undef DO

}
static void struct_destroy()
{
#define DO(x)  destroy_ ## x  ();
DO_STUFFS
#undef DO
}
static void save_struct_t() 
{
#define DO(x)  save_ ## x ();
DO_STUFFS
#undef DO
}

static void check_struct_t() 
{
#define DO(x)  check_ ## x ();
DO_STUFFS
#undef DO
}



#undef DO_STUFFS
