/*
 *
 *	(c) Petr Susil 2006 <susa@atrey.karlin.mff.cuni.cz>
 *
 *	This software may be freely distributed and used according to the terms
 *	of the GNU General Public License.
 */
#define SUFFIX  struct2
#include "init.h" 

//#define STR_HASH_FCE
#define NUM_HASH_FCE

#define COMPAR_INSERTED \
	  read_int(file,records+sizeof(uint32_t)*0)==i->key_adr &&\
	  read_int(file,records+sizeof(uint32_t)*1)==i->data 

#define __PRINT_ITEM(x)

#define COMPAR_ITEM(i1,i2) \
      ( i1->key_adr  != i2->key_adr )\
  ||  ( i1->data != i2->data)

#define KEY_RETURN return adr;
#define LENGTH_ITEM sizeof(uint32_t)*2
#define COMPAR_KEY(key1,key2,hash1,hash2)                  \
if ( *(uint32_t*) key1<*(uint32_t*) key2) return -1;       \
  else if  ( *(uint32_t*) key1>*(uint32_t*) key2) return 1;\
  else return 0;

#define DODO_READ(suffix,x)                           \
  x ->key_adr = read_int(file,adr+sizeof(uint32_t)*0);\
  x ->data    = read_int(file,adr+sizeof(uint32_t)*1);\
  x ->key     = & x ->key_adr;                        \
  x ->is_chain  = HAS_MASK(x->data);                  \
  x ->data      = UNMASK(x->data);


#define DODO_SREAD(suffix,x)\
  x ->key     = 0;\
  x ->data    = read_int(file,adr+sizeof(uint32_t)*0);\

#define WRITE \
	  write_int(file,records+sizeof(uint32_t)*0,i->key_adr );\
	  write_int(file,records+sizeof(uint32_t)*1 \
		    ,i->is_chain                    \
		    ?MASK(i->data)                  \
		    :i->data );           

#define DODO_STRUCT_DEF(x)\
typedef struct {\
  union {\
     uint32_t hash;      /* compatibility with string.h only */\
     uint32_t key_adr;\
     uint32_t filename_adr;  /* pro file_item ma byt stejny jako key_adr pro ostatni jen z duvodu komaptibility */\
  };\
  union {\
     uint32_t data;\
     uint32_t chain_adr;\
     uint32_t identifier_adr;  /* jen z duvodu komaptibility */\
  };\
  const uint32_t* key;\
  int is_chain;\
} __item_ ## x;

#include "template.h" 

#ifndef __FILE_ITEM_FUNCTION
#define __FILE_ITEM_FUNCTION
uint32_t get_file_item_identifier(const void* item)
{
  return ((__item_struct2*) item )->identifier_adr;
}
uint32_t get_file_item_filename(const void* item)
{
  return ((__item_struct2*) item )->filename_adr;
}
#endif

#include "destroy.h" 


