/*
 *
 *	(c) Petr Susil 2006 <susa@atrey.karlin.mff.cuni.cz>
 *
 *	This software may be freely distributed and used according to the terms
 *	of the GNU General Public License.
 */

static char* cmd_cond_output_macro_use_macro;
static char* cmd_cond_output_macro_use_filename;
int cmd_cond_output_macro_use     (struct symbol* sym, struct token* tok) 
{
  if (
      !strcmp(sym->ident->name
	      ,cmd_cond_output_macro_use_macro) 
      && !strcmp(stream_name(tok->pos.stream)
		 ,cmd_cond_output_macro_use_filename))
    return 1;
  return 0;
}

void get_macro_use_file(const char* macro, const char* file)
{
  add_push();
  char* f = malloc ( strlen(file) +1 );
  strcpy(  f, file);
  add_function(mac_use
	       , output_macro_use
	       , cmd_cond_output_macro_use);

  cmd_cond_output_macro_use_filename=f;

  spotsparse_file(f);

  free(f);
  add_pop();
}

