/*
 *
 *	(c) Petr Susil 2006 <susa@atrey.karlin.mff.cuni.cz>
 *
 *	This software may be freely distributed and used according to the terms
 *	of the GNU General Public License.
 */

static void write_struct_content_cmd(struct symbol* sym)
{
  struct symbol* s;
  FOR_EACH_PTR(sym->symbol_list, s) {
    switch (s->type)
      {
      case SYM_NODE:
	//	fprintf(stderr,"namespace=%d\n",s->namespace);;
	if (!s->ident)
	  {
	    write_struct_content_cmd(s->ctype.base_type);
	    continue;
	  }
	WRITE4(  s->ident->name
		 , stream_name(s->pos.stream)
		 , s->pos.line
		 , s->pos.pos
		 );
	//	WRITE_IDENT(s->ident->name);
	break;
      default:
	fprintf(stderr,"default at output struct dec\n");
	break;
      }
  } END_FOR_EACH_PTR(s);
}



static const char* structure_content_file;
static const char* structure_content_ident;

static void output_struct_def_cmd      (struct symbol* sym )
{
  /* 
     muze se stat ze bude k definici dvou ruznych struktur pouzit tentyz identifikator?
     pokud ano pak popremyslet zda resit a jak
   */
#ifdef MY_WARNINGS
#warning !!! nekontroluju soubor - ? muze byt vice definici k danemu identifikatoru? -> chci vsechny?
#endif
  if (strcmp(sym->ident->name,structure_content_ident)) return;

/*   if (structure_content_file  */
/*       && strcmp(stream_name(sym->pos.stream) */
/* 		,structure_content_file)) return; */
  printf ("definition of ");
  WRITE4(  sym->ident->name
	   , stream_name(sym->pos.stream)
	   , sym->pos.line
	   , sym->pos.pos
	   );

  write_struct_content_cmd(sym);
}


const char** get_database_struct_def_files (const char* ident); /* database.c */
void get_structure_content_cmd (const char* ident)
{

  int old_show_active_file=show_active_file;
  show_active_file=0;

  add_functions_t f = add_functions_backup();

  add_struct_def = output_struct_def_cmd;
  structure_content_ident=(char*) malloc(strlen(ident+1));
  strcpy((char*) structure_content_ident,ident);
  if ( 1 )
    {
      xalloc_context local_context;
      memset(&local_context,0,sizeof(xalloc_context));
      xalloc_context* context = xalloc_get_context();
      xalloc_set_context(&local_context);

      const char** f = get_database_struct_def_files(ident);
      if(!f) 
	{
	  
	  xalloc_set_context(context);
	  show_active_file = old_show_active_file;
	  free((void*)structure_content_ident);
	  return;
	}

      const char** g; for(g=f;*g;g++)
	spotsparse_file(*g); 
      
      xalloc_set_context(&local_context);
      xfree(f);
      xfree_all();
      xalloc_set_context(context);
    }
  else 
    {
      //      spotsparse_file_and_do_stuff(file);
    }
  free((void*)structure_content_ident);
  add_functions_restore(f);
  structure_content_ident=structure_content_file=0;  
  show_active_file = old_show_active_file;
}

